// This file is not for the faint of heart. But it can be significantly
// improved by those daring to.

// if we should link to memory management routines in J dll instead
// of j701b implementation. Note that currently linking is only
// possible on Linux.
// #define LINK_J_MEM_MNGMT
#include "config.h"
#ifndef LINK_J_MEM_MNGMT
#include <cstring>
#if SY_WIN32 && !SY_WINCE
#include <heapapi.h>
#define FREE(a)     HeapFree(jt->heap,0,a)
#define MALLOC(n)   (I*)HeapAlloc(jt->heap,0,n)
#undef INT
#undef R
#else
#define FREE(a) free(a)
#define MALLOC(n) (I*)malloc(n)
#endif
#endif

#include "jengine.h"
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <ltdl.h>
#include <cassert>
#include <sstream>
#include <map>


const bool TRACEMEM=false;

// typedef jarray::B B;
// typedef jarray::C C;
// typedef jarray::S S;
// typedef jarray::I I;
// typedef jarray::D D;
// typedef jarray::Z Z;

// --------- J typedefs.
// The below inclusion of a portion of J interface is needed to access
// the ttop variable of J instance to be able to cooperate with J
// garbage collection. In principle this all can be replaced by a single
// numeric offset to ttop, but that will have to be calculated for all
// possible platforms and architectures. By including the J typedefs we
// try to ensure the proper access to ttop on all architectures, which J
// supports.
#include "js.h"
#if SY_WINCE                                                                                
#define NFCALL          100L            /* wince     named fn call depth   */               
#define NFDEP           200L            /* wince           fn call depth   */               
#endif                                                                                      
#if SYS & SYS_MACOSX                                                                        
#define NFCALL           9000L          /* darwin    named fn call depth   */               
#define NFDEP           18000L          /* darwin          fn call depth   */               
#endif                                                                                      
#ifndef NFCALL                                                                              
#define NFCALL          10000L          /* all other named fn call depth   */               
#define NFDEP           20000L          /* all other       fn call depth   */               
#endif                                                                                      

#define NALP            256             /* size of alphabet                */               
#define NETX            2000            /* size of error display buffer    */               
#define NPATH           1024            /* max length for path names,      */               
                                        /* including trailing 0 byte       */
#define MLEN            (SY_64?63:31)

#include "jtype.h"
#include "jt.h"
// --------- end of J typedefs

#ifdef LINK_J_STATICALLY
extern "C" J _stdcall JInit();                         /* init instance */
extern "C" void _stdcall JSM(J jt, void*callbacks[]);  /* set callbacks */
extern "C" int _stdcall JDo(J jt,C*);                  /* run sentence */
extern "C" C* _stdcall JGetLocale(J jt);               /* get locale */
extern "C" int _stdcall JFree(J jt);                   /* free instance */
extern "C" int _stdcall JGetM(J jt, C* name, I* jtype, I* jrank, I* jshape, I* jdata);
extern "C" int _stdcall JSetM(J jt, C* name, I* jtype, I* jrank, I* jshape, I* jdata);
extern "C" void* jtga(J jt,I t,I n,I r,I*s);
extern "C" void jtfr(J jt,void* w);
extern "C" void* jtgc (J jt,void* w,I old);
extern "C" void* jttpush(J jt, void* w);
extern "C" I jttpop(J jt,I old);
#endif

typedef void* (_stdcall *JInitType)     ();
typedef int   (_stdcall *JDoType)       (J, C*);
typedef C*    (_stdcall *JGetLocaleType)(J);
typedef void  (_stdcall *JSMType)       (J, void*);
typedef void  (_stdcall *JFreeType)     (J);
typedef int   (_stdcall *JGetMType)     (J jt, C* name, I* jtype, 
					 I* jrank, I* jshape, I* jdata);
typedef int   (_stdcall *JSetMType)     (J jt, C* name, I* jtype,
					 I* jrank, I* jshape, I* jdata);

typedef void* (*jtgaType)      (J jt, const I t, const I n, const I r, const I* s);
typedef void  (*jtfrType)      (J jt, void* A);
typedef void* (*jtgcType)      (J jt, void* w, I old);
typedef void* (*jttpushType)   (J jt, void* w);
typedef I     (*jttpopType)    (J jt, I oldtop);

std::ostream *out=NULL;

void _stdcall Joutput(J jt,I type, C* s) {
  // output type                                                                  const I MTYOFM  = 1;       /* formatted result array output */             
  const I MTYOER  = 2;       /* error output */                              
  const I MTYOLOG = 3;       /* output log */                                
  const I MTYOSYS = 4;       /* system assertion failure */                  
  const I MTYOEXIT = 5;      /* exit */                                      
  const I MTYOFILE= 6;       /* output 1!:2[2 */

  if (MTYOEXIT==type) { // J wants us to exit
    exit((int)(I)s);
  };
  (*out) << s << std::flush;
};

#ifndef LINK_J_STATICALLY
#ifndef LINK_J_MEM_MNGMT
// implementations of J memory management routines from J701b
// from j.h
#define SZA             ((I)sizeof(A))
#define SZI             ((I)sizeof(I))
#define NTSTACK         2000L           /* size of stack for temps         */

#define ASSERT(b,e)     assert(b)
#define ASSERTSYS(b,s)  assert(b)
#define CALL1(f,w,fs)   ((f)(jt,    (w),(A)(fs)))
#define DO(n,stm)       {I i=0,_n=(n); for(;i<_n;i++){stm}}
#define ICPY(z,w,n)     memcpy((z),(w),(n)*SZI)
#define JBREAK0         {}
#define MAX(a,b)        ((a)>(b)?(a):(b))
#define R               return
#define RZ(exp)         {if(!(exp))R 0;}

static A   mark=0;               /* parser marker                        */

// from jc.h
#define C0         '\000'       /*   0 000 00                              */

#define LOCPATH(g)      ((*AV(g)+jt->sympv)->val )
#define LOCNAME(g)      ((*AV(g)+jt->sympv)->name)

// from jerr.h
#define EVLIMIT         10
#define EVWSFULL        22

// from m.h
typedef struct {I*a;S j;C mflag,unused;} MS;

/* layout of the two words before every A array                            */
/* a: ptr to next block (when in free list)                                */
/*    address of SMM array, or 0 (when allocated)                          */
/* j: mfree/msize index                                                    */
/* mflag: bit flags                                                        */

#define MFHEAD  1      /* head of 64k block (returned by malloc() */

// from u.c
I bp(I t){
 switch(t){
  case B01:  R sizeof(B);
  case LIT:  case ASGN: case NAME:
             R sizeof(C);
  case C2T:  R sizeof(C2);
  case INT:  case LPAR: case RPAR: case MARK: case SYMB:
             R sizeof(I);
  case FL:   R sizeof(D);
  case CMPX: R sizeof(Z);
  case BOX:  R sizeof(A);
  case XNUM: R sizeof(X);
  case RAT:  R sizeof(Q);
  case SB01: case SINT: case SFL:  case SCMPX: case SLIT: case SBOX:
             R sizeof(P);
  case VERB: case ADV:  case CONJ:
             R sizeof(V);
  case CONW: R sizeof(CW);
  case SBT:  R sizeof(SB);
#ifdef UNDER_CE
  default:   R t&XD?sizeof(DX):t&XZ?sizeof(ZX):-1;
#else
  case XD:   R sizeof(DX);
  case XZ:   R sizeof(ZX);
  default:   R -1;
#endif
}}

// from m.c
#define PSIZE       65536L         /* size of each pool                    */
#define PLIM        1024L          /* pool allocation for blocks <= PLIM   */
#define PLIML       10L            /* base 2 log of PLIM                   */

I mhb=sizeof(MS);                  /* # bytes in memory header             */
I mhw=sizeof(MS)/SZI;              /* # words in memory header             */

I   msize[MLEN]={0};      /* m.c size of blocks in mfree[i]       */
static void jplus_jtmeminit() {
	I k,m=MLEN;
  k=1; DO(m, msize[i]=k; k+=k;);
}

// memory allocator
static A jplus_jtma(J jt,I m){A z;C*u;I j,n,p,*v;MS*x;
 n=p=m+mhb;
 ASSERT(n<=jt->mmax,EVLIMIT);
 j=6; n>>=j;
 while(n){n>>=1; ++j;}
 if(p==msize[j-1])--j;
 n=msize[j];
 if(jt->mfree[j]){         /* allocate from free list         */
	z=(A)(mhw+jt->mfree[j]);
  jt->mfree[j]=((MS*)(jt->mfree[j]))->a;
  jt->mfreeb[j]-=n;
 }else if(n>PLIM){         /* large block: straight malloc    */
	v=MALLOC(n);
  ASSERT(v,EVWSFULL);
  z=(A)(v+mhw);
	 }else{                    /* small block: do pool allocation */
	v=MALLOC(PSIZE);
  ASSERT(v,EVWSFULL);
  u=(C*)v; DO(PSIZE/n, x=(MS*)u; u+=n; x->a=(I*)u; x->j=(C)j; x->mflag=0;); x->a=0;
  ((MS*)v)->mflag=MFHEAD;
  z=(A)(mhw+v);
  jt->mfree[j]=((MS*)v)->a;
  jt->mfreeb[j]+=PSIZE-n;
 }
 JBREAK0;
 jt->bytes+=n; jt->bytesmax=MAX(jt->bytes,jt->bytesmax);
 x=(MS*)z-1; x->a=0; x->j=(C)j;
 R z;
}

static void jplus_jtfr(J jt,A w){I j,n;MS*x;
 if(!w||--AC(w))R;
 x=(MS*)w-1;
 j=x->j; n=msize[j];
 jt->bytes-=n;
 if(PLIML<j)FREE(x);  /* malloc-ed       */
 else{                /* pool allocation */
  x->a=jt->mfree[j];
  jt->mfree[j]=(I*)x;
  jt->mfreeb[j]+=n;
}}

#define fr(x)                       jplus_jtfr(jt,(x))
#define ma(x)                       jplus_jtma(jt,(x))
#define ra(x)                       jplus_jtra(jt,(x))
#define tf()                        jplus_jttf(jt)
#define tg()                        jplus_jttg(jt)
#define tpush(x)                    jplus_jttpush(jt,(x))
#define tpop(x)                     jplus_jttpop(jt,(x))
#define traverse(x,y)               jplus_jttraverse(jt,(x),(y))

static A jplus_jttg(J jt){A t=jt->tstacka,z;
 RZ(z=ma(SZI*WP(BOX,NTSTACK,1L)));
 AT(z)=BOX; AC(z)=AR(z)=1; AN(z)=*AS(z)=NTSTACK; AM(z)=NTSTACK*SZA; AK(z)=AKX(z);
 jt->tstacka=z; jt->tstack=AAV(jt->tstacka); jt->tbase+=NTSTACK; jt->ttop=1;
 *jt->tstack=t;
 R z;
}

typedef A                (*AFJP)(J jt,A w, A p);

//
static A jplus_jttraverse(J jt,A w,AFJP f){
 RZ(w);
 switch(AT(w)){
  case XD:
   {DX*v=(DX*)AV(w); DO(AN(w), CALL1(f,v->x,0L); ++v;);} break;
  case RAT:
   {A*v=AAV(w); DO(2*AN(w), CALL1(f,*v++,0L););} break;
  case XNUM: case BOX:
   if(!(AFLAG(w)&AFNJA+AFSMM)){A*wv=AAV(w);I wd=(I)w*ARELATIVE(w); DO(AN(w), CALL1(f,WVR(i),0L););} break;
  case VERB: case ADV:  case CONJ:
   {V*v=VAV(w); CALL1(f,v->f,0L); CALL1(f,v->g,0L); CALL1(f,v->h,0L);} break;
  case SYMB:
   {I k,*v=1+AV(w);L*u;
    CALL1(f,LOCPATH(w),0L);
    CALL1(f,LOCNAME(w),0L);
    DO(AN(w)-1, if(k=*v++){u=k+jt->sympv; CALL1(f,u->name,0L); CALL1(f,u->val,0L);});
   } break;
  case SB01: case SINT: case SFL: case SCMPX: case SLIT: case SBOX:
   {P*v=PAV(w); CALL1(f,SPA(v,a),0L); CALL1(f,SPA(v,e),0L); CALL1(f,SPA(v,i),0L); CALL1(f,SPA(v,x),0L);} break;
 }
 R mark;
}

// temporary stack push
static A jplus_jttpush_(J jt, A w, A p) {
 RZ(w);
 traverse(w,jplus_jttpush_);
 if(jt->ttop>=NTSTACK)RZ(tg());
 jt->tstack[jt->ttop]=w;
 ++jt->ttop;
 R w;
};
static A jplus_jttpush(J jt, A w) {
	R jplus_jttpush_(jt,w,0L);
}

static void jplus_jttf(J jt){A t=jt->tstacka;
 jt->tstacka=*jt->tstack; jt->tstack=AAV(jt->tstacka); jt->tbase-=NTSTACK; jt->ttop=NTSTACK;
 fr(t);
}

static I jplus_jttpop(J jt,I old){
 while(old<jt->tbase+jt->ttop)if(1<jt->ttop)fr(jt->tstack[--jt->ttop]); else tf();
 R old;
}
static A jplus_jtra_(J jt, A w, A p) {RZ(w); traverse(w,jplus_jtra_); ++AC(w); R w;   }
static A jplus_jtra(J jt, A w) {R jplus_jtra_(jt,w,0L);}
static A jplus_jtgc (J jt,A w,I old){ra(w); tpop(old); R tpush(w);}

// array allocator
void* jplus_jtga(J jt, const I t, const I n, const I r, const I* s) {A z;I m,w;
 assert((t&BIT)==0);
 w=WP(t,n,r);     m=SZI*w;
 ASSERT(m>n&&n>=0&&m>w&&w>0,EVLIMIT);   /* beware integer overflow */
 RZ(z=ma(m));
 if(!(t&DIRECT))memset(z,C0,m);
 if(t&LAST0){I*v=(I*)z+w-2; *v++=0; *v=0;}
 AC(z)=1; AN(z)=n; AR(z)=r; AFLAG(z)=0; AK(z)=AKX(z); AM(z)=msize[((MS*)z-1)->j]-(AK(z)+sizeof(MS));
 AT(z)=0; tpush(z); AT(z)=t;
 if(1==r&&!(t&SPARSE))*AS(z)=n; else if(r&&s)ICPY(AS(z),s,r);  /* 1==n always if t&SPARSE */
 R z;
}

// to this end we have the following memory management functions defined
// static void jplus_jtmeminit();  // must be called at initialization
// void* _stdcall jplus_jtga(J jt, const I t, const I n, const I r, const I* s);
// static void _stdcall jplus_jtfr(J jt,A w);
// static A _stdcall jplus_jtgc (J jt,A w,I old){ra(w); tpop(old); R tpush(w);}
// static A _stdcall jplus_jttpush(J jt, A w);
// static I _stdcall jplus_jttpop(J jt,I old);

#endif // LINK_J_MEM_MNGMT
#endif // LINK_J_STATICALLY

class jengine::Impl {
public:
  static JInitType pJInit;
  static JSMType pJSM;
  static JDoType pJDo;  
  static JGetMType pJGetM;
  static JSetMType pJSetM;
  static JFreeType pJFree;
  static jtgaType pjtga;
  static jtfrType pjtfr;
  static jtgcType pjtgc;
  static jttpushType pjttpush;  
  static jttpopType pjttpop;  
  static lt_dlhandle libj;
  int err;

static void initJlibrary(std::ostream& o) {
#ifdef LINK_J_STATICALLY
	out=&o;
	pJInit=(JInitType)&JInit;
	pJSM=(JSMType)&JSM;
	pJDo=(JDoType)&JDo;
	pJGetM=(JGetMType)&JGetM;
	pJSetM=(JSetMType)&JSetM;
	pJFree=(JFreeType)&JFree;
	pjtga=(jtgaType)&jtga;
	pjtfr=(jtfrType)&jtfr;
	pjtgc=(jtgcType)&jtgc;
	pjttpush=(jttpushType)&jttpush;
	pjttpop=(jttpopType)&jttpop;
#else
		if (!libj) {
	out=&o;
	int error = lt_dlinit ()     /* Initialise libltdl. */
		|| lt_dladdsearchdir (".")    /* set the search path. */
		|| lt_dladdsearchdir ("./thirdparty/j")  
		|| lt_dladdsearchdir ("../thirdparty/j")
#ifdef JDLLDIR
		|| lt_dladdsearchdir (JDLLDIR)
#endif
		|| lt_dladdsearchdir ("../../thirdparty/j") /* this makes "make distcheck" work */
		|| lt_dladdsearchdir ("../../../thirdparty/j") /* same in ./build/ */
		|| !((libj=lt_dlopenext("libj"))||(libj=lt_dlopenext("j"))); /* load */
      
	if (error) {
		fprintf(stderr, "Fatal error loading J engine: %s\n", lt_dlerror ());
		exit(9);
	};
	// ok, we loaded the engine, now set the entry points
	error = !(
						(pJInit=(JInitType)lt_dlsym(libj, "JInit")) &&
						(pJSM=(JSMType)lt_dlsym(libj, "JSM")) &&
						(pJDo=(JDoType)lt_dlsym(libj, "JDo")) &&
						(pJGetM=(JGetMType)lt_dlsym(libj, "JGetM")) &&
						(pJSetM=(JSetMType)lt_dlsym(libj, "JSetM")) &&
						(pJFree=(JFreeType)lt_dlsym(libj, "JFree")));
#ifdef LINK_J_MEM_MNGMT
	// continue linking functions from j.dll
	error = !( (!error) && (pjtga=(jtgaType)lt_dlsym(libj, "jtga")) &&
						 (pjtfr=(jtfrType)lt_dlsym(libj, "jtfr")) &&
						 (pjtgc=(jtgcType)lt_dlsym(libj, "jtgc")) &&
						 (pjttpush=(jttpushType)lt_dlsym(libj, "jttpush")) &&
						 (pjttpop=(jttpopType)lt_dlsym(libj, "jttpop")) 
						 );
#else
	// link our own copy of memory management functions
	jplus_jtmeminit();
	pjtga=(jtgaType)&jplus_jtga;
	pjtfr=(jtfrType)&jplus_jtfr;
	pjtgc=(jtgcType)&jplus_jtgc;
	pjttpush=(jttpushType)&jplus_jttpush;
	pjttpop=(jttpopType)&jplus_jttpop;
#endif
	if (error) {
		fprintf(stderr, "Fatal error resolving J symbols: %s\n", lt_dlerror ());
		fprintf(stderr, "pJInit = %p\npJSM = %p\npJDo = %p\npJGetM = %p\n"
						"pSetA = %p\npJFree = %p\n",pJInit, pJSM, pJDo,pJGetM,
						pJSetM,pJFree);
		exit(9);
	};
 }
#endif // LINK_J_STATICALLY
}

  // Pointer to J instance. Even though it is a class variable, only one 
  // instance of J engine can be active at a time. This is because J does
  // not allow callbacks to function with multiple instances. This limitation
  // may be lifted in future (jengine code is ready for this).
  J jt;

  // pointer back to jengine, owning this ::Impl
  jengine *je;

  // callbacks into J engine for calling adverb verb arguments
  // monadically and dyadically.
  typedef int (_stdcall *verbcallback) ();               // 0 arg
  typedef int (_stdcall *monadcallback) (int y);         // 1 arg
  typedef int (_stdcall *dyadcallback)  (int x, int y);  // 2 args
 
  // because these variables are static, only a single J instance will
  // properly support user-defined adverbs. While this can be done differently
  // here, note that J itself does not support multiple-instance callbacks.
  static verbcallback verbcb;   // return the top of verbstack as text
  static monadcallback monadcb; // execute top of verbstack monadically
  static dyadcallback dyadcb;   // execute top of verbstack dyadically
  
  bool doJ(const std::string s) {
    I err=pJDo(jt, const_cast<char *>(s.c_str()));
    return err==0;
  };
  
  void *GA(const I t, const I n, const I r, const I* s) {
    return pjtga(jt,t,n,r,s);
  };

  void FR(void* hdr) {
    pjtfr(jt,hdr);
  };

  jarray::I PROLOG() {
    return jt->tbase+jt->ttop;
  };
  jarray::I EPILOG(jarray::I oldtop) {
		if (TRACEMEM) {
			std::cerr<< "EPILOG: " << ((jt->tbase+jt->ttop) - oldtop) 
							 << " temporaries will be freed." << std::endl;
		}
    return pjttpop(jt,oldtop);
  };
  void* EPILOG(jarray::I oldtop, void *reshdr) {
		if (TRACEMEM) {
			std::cerr<< "EPILOG: " << ((jt->tbase+jt->ttop) - oldtop) 
							 << " temporaries will be freed, "
							 << (jarray::I)reshdr<<" remains." << std::endl;
		}
    return pjtgc(jt, reshdr, oldtop);
  };

  // retrieves a named array from J
  const jarray get(const std::string name) {
    I jtype, jrank;
    I* jshape;
    void* jdata;
    err=pJGetM(jt, const_cast<char *>(name.c_str()), 
	       &jtype, &jrank, (I*)&jshape, (I *)&jdata);
    if (!err)  {
      // what we now actually need is just the beginning of the header,
      // which is always 7 words before the shape array.
      jarray res(je, jshape-7);
      return res;
    } else {
      jarray res;
      return res;
    };
  };

  static std::ostream & print_J_pointer(std::ostream &o, const jarray::I iptr) {
    if (iptr<0) 
      o<<'_'<<(-iptr);
    else
      o<<iptr;
    return o;
  };

  // assigns J name to the specified array
  bool set(const std::string name, jarray &value) {
		if ((this->je)==value.getEngine()) {
			if (TRACEMEM)
				std::cerr<< "passing \"" << name << "\" to J directly." << std::endl;
			// if the array is managed by the same J engine
			using namespace std;
			// this would not copy the array data, although parsing is required.
			ostringstream str;
			str << name << "=:" << "(15!:7) ";
			print_J_pointer(str, value.getHeader());
			return doJ(str.str());
		} else {
			// if it is an array from a different engine or is malloced:
			// this will implicitly copy data.
			if (TRACEMEM)
				std::cerr<< "passing \"" << name << "\" to J via SetM." << std::endl;
			I type=value.type();
			I rank=value.rank();
			I* shape=value.shape();
			I* data=value.data();
			err=pJSetM(jt, const_cast<char *>(name.c_str()), 
								 &type, &rank, (I*)&shape, (I*)&data);
			return err==0;
		}
  };

  void stackHighlight(I addr, I oldttop) {
    std::cerr << '[';
    std::cerr << addr;
    std::cerr << ',';
    for (int i=0; i<jt->ttop; i++) {
      if ((oldttop>0)&&(oldttop==jt->tbase+i))
	std::cerr<<'|';
      if (((I)jt->tstack[i])==addr) std::cerr<<'*';
    };
    std::cerr << ']';
  };

  // this gets called from J, yielding us: the pointer to (this) jengine
  // the address of the c++ monad to call and the address of J symbol for
  // the argument of the monad.
  typedef struct {
    void* name;
    void* value;
  } Jsymbol;
  static _stdcall jarray::I monadadaptor(jengine *this_, monad mf, Jsymbol* ysymb) {
    jarray y(this_, ysymb->value);
    if (TRACEMEM) {
      std::cerr << std::endl;
      std::cerr << "- y"; this_->pImpl->stackHighlight((I)ysymb->value,0);
      std::cerr << " refcount of y was at start " << y.getRefcount()-1 << std::endl;
    };    
    jarray::I _ttop=this_->PROLOG();
    jarray r=mf(y);
    assert(r.getEngine()==this_->pImpl->je);  // the array we pass back to J,
                                              // should be allocated by this 
                                              // jengine instance
    I rhdr=r.getHeader();
    this_->EPILOG(_ttop, (void*)rhdr);
    if (TRACEMEM) {
      std::cerr << "- OUT"; this_->pImpl->stackHighlight(rhdr, _ttop);
      std::cerr << " refcount at OUT is now " << r.getRefcount() << std::endl;
    };
    return rhdr;
  };
  static _stdcall jarray::I dyadadaptor(jengine *this_, dyad df, Jsymbol* xsymb, Jsymbol* ysymb) {
    jarray x(this_, xsymb->value);
    if (TRACEMEM) {
      std::cerr << std::endl;
      std::cerr << "-- x"; this_->pImpl->stackHighlight((I)xsymb->value,0);
      std::cerr << " refcount of x was at start " << x.getRefcount()-1 << std::endl;
    };
    jarray y(this_, ysymb->value);
    if (TRACEMEM) {
      std::cerr << "-- y"; this_->pImpl->stackHighlight((I)ysymb->value,0);
      std::cerr << " refcount of y was at start " << y.getRefcount()-1 << std::endl;
    };
    I _ttop=this_->PROLOG();
    jarray r=df(x,y);
    assert(r.getEngine()==this_->pImpl->je);  // the array we pass back to J,
                                              // should be allocated by this 
                                              // jengine instance
    I rhdr=r.getHeader();
    this_->EPILOG(_ttop, (void*)rhdr);
    if (TRACEMEM) {
      std::cerr << "-- OUT"; this_->pImpl->stackHighlight(rhdr, _ttop);
      std::cerr << " refcount at OUT is now " << r.getRefcount() << std::endl;
    };
    return rhdr;
  };
  
  // scripts, defined in J+
  static std::map<std::string,std::string> builtins;
  bool isBuiltin(std::string name) const {
    return builtins.count(name)>0;
  };
  std::set<std::string> getBuiltins() const {
    std::set<std::string> res;
    std::map<std::string,std::string>::iterator it;
    for(it=builtins.begin();it!=builtins.end(); it++)
      res.insert((*it).first);
    return res;
  };
  static jarray topverbasstring(jengine *je) {
    using namespace std;
    // if the argument array is invalid, which should never happen
    // normally, return the verb textual representation
    jarray verb=jarray(je, (void *)verbcb());
    verb.release(); // now we own this memory
    // J does a very good service, fixing a verb ! But, in our case
    // the string version would contain memory addresses of various
    // callbacks. This defies its usefullness for hashing.
    // Here the returned string is scanned and all the stringified
    // scripts are replaced back by their names.
    string str;
    verb.get(str);
    map<string,string>::iterator it;
    for (it=builtins.begin() ; it != builtins.end(); it++ ) {
      string name=(*it).first;
      string text=(*it).second;
      // replace all occurences of text by name
      int i = 0;
      while((i = str.find(text, i)) != string::npos) {
	str.replace(i, text.length(), name);
	i+=name.length();
      };
    };
    jarray nverb(je, str);
    return nverb;
  };
  // these dispatch the calls to J callback
  static jarray monadcbadaptor(jarray y) {
    jengine *je_=y.getEngine();
    if (TRACEMEM) {
      std::cerr << std::endl;
      std::cerr << "+ refcount of y, "<<",";
      je_->pImpl->stackHighlight(y.getHeader(false), 0);
      std::cerr<<" at cb " << y.getRefcount() << std::endl;    
    };
    I _ttop=je_->PROLOG();
    if (TRACEMEM) std::cerr << "+ttop=" << _ttop << std::endl;
    void* reshdr=(void *)monadcb(y.getHeader(false));
    jarray ra=jarray(je_, reshdr);
		pjttpush(je_->pImpl->jt, reshdr);
    if (TRACEMEM) {
      std::cerr << "+ OUT"; 
      je_->pImpl->stackHighlight((I)reshdr, _ttop); 
      std::cerr << std::endl;
    };
    return ra;
  };
  static jarray dyadcbadaptor(jarray x, jarray y) {
    if (!y.isValid()) return topverbasstring(x.getEngine());
    assert(x.getEngine()==y.getEngine());
    jengine *je_=y.getEngine();
    if (TRACEMEM) {
      std::cerr << std::endl;
      std::cerr << "++ refcount of x, "<<",";
      je_->pImpl->stackHighlight(x.getHeader(false), 0);
      std::cerr<<" at cb " << x.getRefcount() << std::endl;    
      std::cerr << "++ refcount of y, "<<",";
      je_->pImpl->stackHighlight(y.getHeader(false), 0);
      std::cerr<<" at cb " << y.getRefcount() << std::endl;    
    };
    I _ttop=je_->PROLOG(); // PROLOG
    if (TRACEMEM) std::cerr << "+ttop=" << _ttop << std::endl;
    void* reshdr=(void *)dyadcb(x.getHeader(false), y.getHeader(false));
    jarray ra=jarray(je_, reshdr);
    pjttpush(je_->pImpl->jt, reshdr);
    if (TRACEMEM) {
      std::cerr << "++ OUT"; 
      je_->pImpl->stackHighlight((I)reshdr, _ttop); 
      std::cerr << std::endl;
    };
    return ra;
  };
  // these pass the callback adaptors to the user-defined adverb code
  static _stdcall jarray::I amonadadaptor(jengine *this_, amonad mf, Jsymbol* ysymb) {
    jarray y(this_, ysymb->value);
    if (TRACEMEM) {
      std::cerr << std::endl;
      std::cerr << "= y"; 
      this_->pImpl->stackHighlight((I)ysymb->value,0);
      std::cerr << " refcount of y was at start " << y.getRefcount()-1 << std::endl;
    };
    I _ttop=this_->PROLOG();
    jarray r=mf(&monadcbadaptor, &dyadcbadaptor, y);
    assert(r.getEngine()==this_->pImpl->je);  // the array we pass back to J,
                                              // should be allocated by this 
                                              // jengine instance
    I reshdr=r.getHeader();
    this_->EPILOG(_ttop, (void*)reshdr);
    if (TRACEMEM) {
      std::cerr << "= OUT"; 
      this_->pImpl->stackHighlight(reshdr, _ttop);
      std::cerr << " refcount at OUT is now " << r.getRefcount() << std::endl;
    };
    return reshdr;
  };
  static _stdcall jarray::I adyadadaptor(jengine *this_, adyad df, Jsymbol* xsymb, Jsymbol* ysymb) {
    jarray x(this_, xsymb->value);
    if (TRACEMEM) {
      std::cerr << std::endl;
      std::cerr << "== x"; 
      this_->pImpl->stackHighlight((I)xsymb->value,0);
      std::cerr << " refcount of x was at start " << x.getRefcount()-1 << std::endl;
    };
    jarray y(this_, ysymb->value);
    if (TRACEMEM) {
      std::cerr << "== y"; 
      this_->pImpl->stackHighlight((I)ysymb->value,0);
      std::cerr << " refcount of y was at start " << y.getRefcount()-1 << std::endl;
    };
    I _ttop=this_->PROLOG();    
    jarray r=df(&monadcbadaptor, &dyadcbadaptor, x,y);
    assert(r.getEngine()==this_->pImpl->je);  // the array we pass back to J,
                                              // should be allocated by this 
                                              // jengine instance
    I reshdr=r.getHeader();
    this_->EPILOG(_ttop, (void*)reshdr);
    //pjttpush(jt, (void*)reshdr);
    if (TRACEMEM) {
      std::cerr << "== OUT"; 
      this_->pImpl->stackHighlight(reshdr, _ttop);
      std::cerr << " refcount at OUT is now " << r.getRefcount() << std::endl;
    };
    return reshdr;
  };

  // defines multiline named script
  bool defScript(std::string name, int type, std::string code, 
		 int mr=jengine::RMAX, 
		 int lr=jengine::RMAX, 
		 int rr=jengine::RMAX) {
    using namespace std;
    // since doJ only executes a single line, script needs to be
    // converted to character codes.
    ostringstream str;
    str << name << "=: " << type << " : (";
    for (int i=0; i<code.size(); i++) str << " " << (int)code[i];
    str << "{ a.)";
    // ranks:
    // by default, explicit verbs have all infinite ranks
    if ((mr!=jengine::RMAX)||(lr!=jengine::RMAX)||(rr!=jengine::RMAX)) {
      str << " \" ";
      if ((lr==rr)&&(mr==lr)) { // all ranks are the same, use short form
	str << mr; // here mr is never infinite
      } else {
	if (mr!=rr) {  // "lr rr is a shorthand for  "rr lr rr
	  if (mr==jengine::RMAX) str << "_"; else str << mr;
	  str << ' ';
	};
	if (lr==jengine::RMAX) str << "_"; else str << lr;
	str << ' ';
	if (rr==jengine::RMAX) str << "_"; else str << rr;
      };
    };
    bool defined=doJ(str.str());
    if (defined) { 
			// here we read back from J and store the fixed version
			// of the script to be able to reduce it back to its
			// name, when the textual version of the verb is requested
			doJ("temporaryname=: '"+name+"' f.");
			doJ("temporaryname=: (5!:5) <'temporaryname'");
			if (TRACEMEM)	std::cerr<< "defScript getting temporary name : ";
			jarray tn=get("temporaryname");
			if (TRACEMEM) std::cerr<<"(\"";
			assert(tn.type()==jarray::T_LIT);
			string text;
			tn.get(text);
			if (TRACEMEM) std::cerr << name << "=: " << text <<" \") : ";
			builtins.insert(pair<string,string>(name,text));
    };
    return defined;
  };

  bool defVerbAdverb(std::string name, jarray::I mf, jarray::I df, bool adverb,
										 int mr=jengine::RMAX, 
										 int lr=jengine::RMAX, 
										 int rr=jengine::RMAX) {
    using namespace std;
    string script;
    {
      ostringstream str;
      if (mf) {
				// monadic case
				// str << "output=. 2&((1!:2)~)" << endl;
				if (adverb) {
					str << "ay =. y" << endl; // black magic, but otherwise 'y' is undefined
					str << "(4!:55) < 'ay'" << endl;
				}
				if (adverb)   // adverb: push verb argument to callback stack
					str << "verbstack =: (verbstack ` u)" << endl << "r =. ";
				str << "(15!:7) '0 ";
				int adaptor=adverb?(jarray::I)&amonadadaptor:(jarray::I)&monadadaptor;
				print_J_pointer(str,adaptor);
				str << " > x x x x' (15!:0) ( ";
				print_J_pointer(str, (jarray::I)je);
				str << ';';
				print_J_pointer(str,mf);
				str << " ; (15!:6) <'y' )" << endl;
				if (adverb)   // adverb: pop verb argument from callback stack
					str << "verbstack =: }: verbstack " << endl << "r" << endl;
				if (df) str << ":" << endl;
      };
      if (df) {
				// dyadic case
        // str << "output=. 2&((1!:2)~)" << endl;
				if (adverb)   // adverb: push verb argument to callback stack
					str << "verbstack =: (verbstack ` u)" << endl << "r =. ";
				str << "(15!:7) '0 ";
				int adaptor=adverb?(jarray::I)&adyadadaptor:(jarray::I)&dyadadaptor;
				print_J_pointer(str,adaptor);
				str << " > x x x x x' (15!:0) ( ";
				print_J_pointer(str, (jarray::I)je);
				str << ';';
				print_J_pointer(str,df);
				str << " ; ((15!:6) <'x') ; (15!:6) <'y' )" << endl;
				if (adverb)   // adverb: pop verb argument from callback stack
					str << "verbstack =: }: verbstack" << endl << "r" << endl;
      };
      script=str.str();
    }
    return defScript(name, (adverb?1:(!mf?4:3)), script, mr, lr, rr);
  };

  bool defVerb(std::string name, monad mf, dyad df,
	       int mr, int lr, int rr) {
    return defVerbAdverb(name, (jarray::I) mf, (jarray::I) df, false, 
			 mr, lr, rr);
  };

  bool defAdverb(std::string name, amonad mf, adyad df) {
    return defVerbAdverb(name, (jarray::I) mf, (jarray::I) df, true);
  };

  Impl(jengine *je_):jt(NULL),je(je_) {
    using namespace std;
#ifndef LINK_J_STATICALLY
    assert(libj&&pJInit&&pJSM&&pJDo&&pJGetM&&pJSetM&&pJFree);
#endif
		
    jt=(J)pJInit();
    if (jt==0) {
	fprintf(stderr, "Fatal error initializing J engine.");
	exit(9);
    }
    
    // smoptions
    const I SMWIN = 0;  /* j.exe    Jwdw (Windows) front end */
    const I SMJAVA = 2; /* j.jar    Jwdp (Java) front end */
    const I SMCON = 3;  /* jconsole */

    void* callbacks[] = {(void*)Joutput,0,/* Jinput */ 0,0,(void*)SMCON};
    pJSM(jt, callbacks);

    err=0;

    // get addresses of callbacks
    {
      doJ("cb =: (15!:13) 0");
      if (TRACEMEM)
				std::cerr<< "getting verb callback : ";
      jarray cb=get("cb");
      assert(cb.type()==jarray::T_INT);
      assert(cb.size()==1);
      int cbint;
      cb.get(cbint,0);
      verbcb=(verbcallback)cbint;
    }

    {
      doJ("cb =: (15!:13) 1");
      if (TRACEMEM)
				std::cerr<< "getting monad callback : ";
      jarray cb=get("cb");
      assert(cb.type()==jarray::T_INT);
      assert(cb.size()==1);
      int cbint;
      cb.get(cbint,0);
      monadcb=(monadcallback)cbint;
    }

    {
      doJ("cb =: (15!:13) 2");
      if (TRACEMEM)
				std::cerr<< "getting dyad callback : ";
      jarray cb=get("cb");
      assert(cb.type()==jarray::T_INT);
      assert(cb.size()==1);
      int cbint;
      cb.get(cbint,0);
      dyadcb=(dyadcallback)cbint;
    }
    doJ("verbstack =: (4!:55) < 'cb'"); // clean up, erase 'cb'
    doJ("verbstack =: ''"); // empty array to serve as verbstack
    
    // define the callback dispatcher in J
    // it takes the verb from the top of verbstack and executes it
    // on given argument arrays monadically or dyadically, as requested.
    string cb(
	      // "output=. 2&((1!:2)~)" "\n"
	      "na =. # y" "\n"
	      "au =. {: verbstack" "\n"
	      "if. (na=1) do." "\n" // monadic call
	      "r =. (au @. 0) (15!:7) y" "\n"
	      "elseif. (na=2) do." "\n"          // dyadic call
	      "r =. ((15!:7) {. y) (au @. 0) ((15!:7) {: y)" "\n"
	      "elseif. (na=0) do." "\n" // verb on top of the stack as text
	      "auf =. ((au @. 0) f.)" "\n"
	      "r =. (5!:5) < 'auf'" "\n"
	      "end." "\n"
	      "ar =. {. (15!:1) ((15!:6) < 'r'),4,1,4" "\n"
	      "rc =. (15!:1) ar,16,1,4" "\n" // refcount
	      "(rc+1) (15!:2) ar,16,1,4" "\n"// artificially inc by 1 to
	                                     // prevent J from freeing the memory
	      "ar" "\n"
	      );
    bool ok=defScript("cdcallback", 3, cb);
    assert(ok);
  }

  ~Impl() {
    pJFree(jt);
    jt=NULL;
  };

private:
  // copy disabled
  Impl(const Impl &);
  const Impl& operator=(const Impl&);
};


JInitType jengine::Impl::pJInit=NULL;
JSMType jengine::Impl::pJSM=NULL;
JDoType jengine::Impl::pJDo=NULL;  
JGetMType jengine::Impl::pJGetM=NULL;
JSetMType jengine::Impl::pJSetM=NULL;
JFreeType jengine::Impl::pJFree=NULL;  
jtgaType jengine::Impl::pjtga=NULL;  
jtfrType jengine::Impl::pjtfr=NULL;  
jtgcType jengine::Impl::pjtgc=NULL;  
jttpushType jengine::Impl::pjttpush=NULL;  
jttpopType jengine::Impl::pjttpop=NULL;  
lt_dlhandle jengine::Impl::libj=NULL;
jengine::Impl::verbcallback jengine::Impl::verbcb=NULL;
jengine::Impl::monadcallback jengine::Impl::monadcb=NULL;
jengine::Impl::dyadcallback jengine::Impl::dyadcb=NULL;

std::map<std::string, std::string> jengine::Impl::builtins;

jengine::jengine():
  pImpl(new jengine::Impl(this)) {
};

jengine::~jengine() {
  delete pImpl;
};

void jengine::initJlibrary(std::ostream & o) {
  jengine::Impl::initJlibrary(o);
}

bool jengine::doJ(const std::string s) {
  return pImpl->doJ(s);
};

// retrieves a named array from J
const jarray jengine::get(const std::string name) {
  return pImpl->get(name);
};

// assigns J name to the specified array
bool jengine::set(const std::string name, jarray &value) {
  return pImpl->set(name,value);
};

// returns J error code for the last unsuccessful operation.
int jengine::getError() {
  return pImpl->err;
};

bool jengine::defVerb(std::string name, monad mf, dyad df,
		      int mr, int lr, int rr) {
  return pImpl->defVerb(name, mf, df, mr, lr, rr);
};

bool jengine::defScript(std::string name, int type, std::string code, 
			int mr, int lr, int rr) {
  return pImpl->defScript(name, type, code, mr, lr, rr);
};

bool jengine::defAdverb(std::string name, amonad mf, adyad df) {
  return pImpl->defAdverb(name, mf, df);
};

bool jengine::isBuiltin(std::string name) const {
  return pImpl->isBuiltin(name);
};

std::set<std::string> jengine::getBuiltins() const {
  return pImpl->getBuiltins();
};

void* jengine::GA(const jarray::I t, const jarray::I n, 
		  const jarray::I r, const jarray::I *s) {
  return pImpl->GA(t,n,r,s);
};
void jengine::FR(void *hdr) {
  pImpl->FR(hdr);
};
jarray::I jengine::PROLOG() {
  return pImpl->PROLOG();
};
jarray::I jengine::EPILOG(jarray::I oldtop) {
  return pImpl->EPILOG(oldtop);
};
void* jengine::EPILOG(jarray::I oldtop, void* reshdr) {
  return pImpl->EPILOG(oldtop, reshdr);
};
